## kiss 0.0.0+p24.04+vunstable+git20250901.0918

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: (C) 2020 Carl Schwan <carl@carlschwan.eu>
# SPDX-FileCopyrightText: (C) 2025 Kristen McWilliam <kristen@kde.org>
#
# SPDX-License-Identifier: BSD-2-Clause

cmake_minimum_required(VERSION 3.20)

project(kiss VERSION "0.1.0")

set(QT_MIN_VERSION "6.6.0")
set(KF_MIN_VERSION "6.5.0")

include(FeatureSummary)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################# set KDE specific information #################
find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat)
include(KDEGitCommitHooks)

include(ECMDeprecationSettings)
include(ECMFindQmlModule)
include(ECMQmlModule)
include(ECMSetupVersion)
include(ECMGenerateExportHeader)
include(ECMPoQmTools)
include(ECMQmlModule)
include(ECMQtDeclareLoggingCategory)

################# Find dependencies #################
find_package(Qt6 ${QT_MIN_VERSION} NO_MODULE COMPONENTS Core Gui Qml QuickControls2 Svg Widgets DBus)
set_package_properties(Qt6 PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required application components"
)
find_package(KF6 ${KF_MIN_VERSION} COMPONENTS Auth CoreAddons I18n Package Config)
set_package_properties(KF6 PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required application components"
)

if (QT_KNOWN_POLICY_QTP0004)
    qt_policy(SET QTP0004 NEW)
endif ()

ecm_setup_version(${PROJECT_VERSION}
    VARIABLE_PREFIX KISS
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/kiss-version.h
)

find_package(KF6Screen CONFIG REQUIRED)
find_package(LibKWorkspace REQUIRED)
find_package(PkgConfig REQUIRED)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

################# build and install #################

configure_file(config-kiss.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kiss.h)

ecm_set_disabled_deprecation_versions(
    QT 6.8.3
    KF 6.13.0
)

add_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING)
add_definitions(-DQT_USE_QSTRINGBUILDER)
add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)

add_subdirectory(files)
add_subdirectory(src)
add_subdirectory(modules)

file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES src/*.cpp src/*.h modules/*.cpp modules/*.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

ki18n_install(po)

ecm_qt_install_logging_categories(
    EXPORT INITIALSYSTEMSETUP
    FILE initialsystemsetup.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

=== files/CMakeLists.txt ===
# SPDX-FileCopyrightText: (C) 2025 Kristen McWilliam <kristen@kde.org>
#
# SPDX-License-Identifier: BSD-2-Clause

configure_file(kde-initial-system-setup.service.in kde-initial-system-setup.service)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/kde-initial-system-setup.service
    DESTINATION ${KDE_INSTALL_SYSTEMDUNITDIR}/system
)

install(
    FILES "kde-initial-system-setup-polkit.rules"
    DESTINATION ${KDE_INSTALL_DATADIR}/polkit-1/rules.d
)

install(
    FILES "kde-initial-system-setup-sysuser.conf"
    DESTINATION  "lib/sysusers.d"
)

configure_file(kde-initial-system-setup-tmpfiles.conf.in kde-initial-system-setup-tmpfiles.conf)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/kde-initial-system-setup-tmpfiles.conf
    DESTINATION "lib/tmpfiles.d"
)

configure_file(kde-initial-system-setup.desktop.in kde-initial-system-setup.desktop)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/kde-initial-system-setup.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/kde-initial-system-setup
)

=== modules/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Carl Schwan <carl@carlschwan.eu>
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: LGPL-2.0-or-later

add_subdirectory(account)
kpackage_install_package(account org.kde.initialsystemsetup.account packages plasma)

# add_subdirectory(cellular)
# kpackage_install_package(cellular org.kde.initialsystemsetup.cellular packages plasma)

add_subdirectory(finished)
kpackage_install_package(finished org.kde.initialsystemsetup.finished packages plasma)

add_subdirectory(keyboard)
kpackage_install_package(keyboard org.kde.initialsystemsetup.keyboard packages plasma)

add_subdirectory(language)
kpackage_install_package(language org.kde.initialsystemsetup.language packages plasma)

add_subdirectory(prepare)
kpackage_install_package(prepare org.kde.initialsystemsetup.prepare packages plasma)

add_subdirectory(screenbrightnessplugin)
kpackage_install_package(screenbrightnessplugin org.kde.initialsystemsetup.screenbrightnessplugin packages plasma)

add_subdirectory(time)
kpackage_install_package(time org.kde.initialsystemsetup.time packages plasma)

add_subdirectory(wifi)
kpackage_install_package(wifi org.kde.initialsystemsetup.wifi packages plasma)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Carl Schwan <carl@carlschwan.eu>
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: BSD-2-Clause

add_subdirectory(auth)
add_subdirectory(bootutil)
add_subdirectory(components)
add_subdirectory(packagestructure)

set_source_files_properties(org.freedesktop.Accounts.xml PROPERTIES NO_NAMESPACE TRUE)
set_source_files_properties(org.freedesktop.Accounts.User.xml PROPERTIES NO_NAMESPACE TRUE)

ecm_qt_declare_logging_category(logging_SRCS
    HEADER "initialsystemsetup_debug.h"
    IDENTIFIER "KDEInitialSystemSetup"
    CATEGORY_NAME "org.kde.initialsystemsetup"
    DESCRIPTION "KDE Initial System Setup"
    EXPORT INITIALSYSTEMSETUP
)

qt_add_dbus_interface(initialstart_DBUS_SRCS
    org.freedesktop.Accounts.xml
    accounts_interface
)

qt_add_dbus_interface(initialstart_DBUS_SRCS
    org.freedesktop.Accounts.User.xml
    user_interface
)

add_executable(kde-initial-system-setup
    main.cpp
    pagesmodel.cpp
    pagesmodel.h
    controller.cpp
    controller.h
    accountcontroller.cpp
    accountcontroller.h
    user.cpp
    user.h
    initialstartutil.cpp
    initialstartutil.h
    keyboardutil.cpp
    keyboardutil.h
    ${initialstart_DBUS_SRCS}
    ${logging_SRCS}
)

# FreeBSD systems might have libxcrypt but their shadow equivalent doesn't use it
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    pkg_check_modules(libxcrypt libxcrypt>=4)
    if(libxcrypt_FOUND)
        target_compile_definitions(kde-initial-system-setup PRIVATE -DHAVE_CRYPT_GENSALT=true)
    else()
        target_compile_definitions(kde-initial-system-setup PRIVATE -DHAVE_CRYPT_GENSALT=false)
    endif()
else()
    target_compile_definitions(kde-initial-system-setup PRIVATE -DHAVE_CRYPT_GENSALT=false)
endif()

ecm_add_qml_module(kde-initial-system-setup GENERATE_PLUGIN_SOURCE
    URI "org.kde.initialsystemsetup"
    DEPENDENCIES
        QtGui
        QtQuick
)

qt_target_qml_sources(kde-initial-system-setup
    QML_FILES
        qml/Main.qml
        qml/Wizard.qml
        qml/LandingComponent.qml
)

target_link_libraries(kde-initial-system-setup
    PUBLIC
        Qt::Widgets
        Qt::Core
        Qt::Gui
        Qt::Qml
        Qt::Quick
        Qt::QuickControls2
        Qt::DBus
        Qt::Svg
        KF6::AuthCore
        KF6::I18n
        KF6::I18nQml
        KF6::Package
        KF6::ConfigGui
        PW::KWorkspace
        crypt
        componentsplugin
        componentspluginplugin
)

install(TARGETS kde-initial-system-setup RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

=== modules/account/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: LGPL-2.1-or-later

ecm_add_qml_module(account
    URI "org.kde.initialsystemsetup.account"
    GENERATE_PLUGIN_SOURCE
)

ecm_finalize_qml_module(account DESTINATION ${KDE_INSTALL_QMLDIR})

=== modules/finished/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: LGPL-2.1-or-later

ecm_add_qml_module(finished
    URI "org.kde.initialsystemsetup.finished"
    GENERATE_PLUGIN_SOURCE
)

ecm_finalize_qml_module(finished DESTINATION ${KDE_INSTALL_QMLDIR})

=== modules/keyboard/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: LGPL-2.1-or-later

ecm_qt_declare_logging_category(logging_SRCS
    HEADER "debug.h"
    IDENTIFIER "KDEInitialSystemSetup"
    CATEGORY_NAME "org.kde.initialsystemsetup.keyboard"
    DESCRIPTION "KDE Initial System Setup Keyboard Module"
    EXPORT INITIALSYSTEMSETUP
)

ecm_find_qmlmodule(org.kde.plasma.private.kcm_keyboard REQUIRED)

ecm_add_qml_module(initialstart_keyboard
    URI "org.kde.initialsystemsetup.keyboard"
    GENERATE_PLUGIN_SOURCE
    DEPENDENCIES
        Qt::Core
)

target_link_libraries(initialstart_keyboard PRIVATE
    Qt::Core
    Qt::Qml
    KF6::I18n
)

ecm_finalize_qml_module(initialstart_keyboard)

=== modules/language/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: LGPL-2.1-or-later

ecm_qt_declare_logging_category(logging_SRCS
    HEADER "initialsystemsetup_language_debug.h"
    IDENTIFIER "KDEInitialSystemSetupLanguage"
    CATEGORY_NAME "org.kde.initialsystemsetup.language"
    DESCRIPTION "KDE Initial System Setup Language Module"
    DEFAULT_SEVERITY Debug
    EXPORT INITIALSYSTEMSETUP_LANGUAGE
)

ecm_add_qml_module(initialstart_language
    URI "org.kde.initialsystemsetup.language"
    GENERATE_PLUGIN_SOURCE
    SOURCES
        languageutil.cpp
        ${logging_SRCS}
    DEPENDENCIES
        Qt::Core
)

target_link_libraries(initialstart_language PRIVATE
    Qt::Core
    Qt::DBus
    Qt::Qml
    KF6::I18n
)

ecm_finalize_qml_module(initialstart_language)

=== modules/prepare/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Devin Lin <devin@kde.org>
# SPDX-License-Identifier: GPL-2.0-or-later

ecm_add_qml_module(initialstart_prepare
    URI "org.kde.initialsystemsetup.prepare.private"
    GENERATE_PLUGIN_SOURCE
)

kconfig_add_kcfg_files(initialstart_prepare colorssettings.kcfgc GENERATE_MOC)

target_sources(initialstart_prepare PRIVATE
    prepareutil.cpp
    prepareutil.h
)

target_link_libraries(initialstart_prepare PRIVATE
    Qt::Core
    Qt::DBus
    Qt::Quick
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::I18n
    KF6::Screen
)

target_compile_definitions(initialstart_prepare PRIVATE -DTRANSLATION_DOMAIN=\"plasma-initial-start-prepare\")

ecm_finalize_qml_module(initialstart_prepare DESTINATION ${KDE_INSTALL_QMLDIR})

=== modules/screenbrightnessplugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Devin Lin <devin@kde.org>
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: GPL-2.0-or-later

ecm_add_qml_module(screenbrightnessplugin
    URI org.kde.initialsystemsetup.screenbrightnessplugin
    GENERATE_PLUGIN_SOURCE
)

qt_add_dbus_interfaces(DBUS_SRCS dbus/org.kde.Solid.PowerManagement.Actions.BrightnessControl.xml)

ecm_qt_declare_logging_category(logging_SRCS
    HEADER screenbrightnessplugin_debug.h
    IDENTIFIER "ScreenBrightnessPlugin"
    CATEGORY_NAME "org.kde.initialsystemsetup.screenbrightnessplugin"
    DESCRIPTION "KDE Initial System Setup: Screen Brightness Plugin"
    EXPORT INITIALSYSTEMSETUP
)

target_sources(screenbrightnessplugin PRIVATE
    screenbrightnessutil.cpp
    ${DBUS_SRCS}
    ${logging_SRCS}
)

target_link_libraries(screenbrightnessplugin PRIVATE
    Qt::Qml
    Qt::DBus
    Qt::Gui
    Qt::Quick
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::I18n
    KF6::Screen
)

ecm_finalize_qml_module(screenbrightnessplugin)

=== modules/time/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Devin Lin <devin@kde.org>
# SPDX-License-Identifier: GPL-2.0-or-later

ecm_add_qml_module(initialstart_time
    URI "org.kde.initialsystemsetup.time.private"
    GENERATE_PLUGIN_SOURCE
)

set_source_files_properties(org.freedesktop.timedate1.xml PROPERTIES NO_NAMESPACE TRUE)

qt_add_dbus_interface(initialstart_time_DBUS_SRCS
    org.freedesktop.timedate1.xml
    timedate_interface
)

target_sources(initialstart_time PRIVATE
    timeutil.cpp
    timeutil.h
    timezonemodel.cpp
    timezonemodel.h
    ${initialstart_time_DBUS_SRCS}
)

target_link_libraries(initialstart_time PUBLIC
    Qt::Core
    Qt::DBus
    Qt::Quick
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::I18n
)

target_compile_definitions(initialstart_time PRIVATE -DTRANSLATION_DOMAIN=\"plasma-initial-start-time\")

ecm_finalize_qml_module(initialstart_time DESTINATION ${KDE_INSTALL_QMLDIR})

=== modules/wifi/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 Kristen McWilliam <kristen@kde.org>
# SPDX-License-Identifier: LGPL-2.1-or-later

ecm_add_qml_module(wifi
    URI "org.kde.initialsystemsetup.wifi"
    GENERATE_PLUGIN_SOURCE
)

ecm_finalize_qml_module(wifi DESTINATION ${KDE_INSTALL_QMLDIR})

=== debian/changelog ===
kiss (0.0.0+p24.04+vunstable+git20250901.0918-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 01 Sep 2025 09:18:56 +0000

kiss (0.0.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 30 Aug 2025 09:35:20 +1000

=== debian/control ===
Source: kiss
Section: kde
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               kf6-kauth-dev,
               kf6-kconfig-dev,
               kf6-kcoreaddons-dev,
               kf6-ki18n-dev,
               kf6-kpackage-dev,
               libkf6screen-dev,
               pkg-kde-tools-neon,
               pkgconf,
               plasma-workspace-dev,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-svg-dev,
               reuse
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/plasma/kiss
Vcs-Git: https://invent.kde.org/neon/neon-packaging/kiss.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/kiss
Maintainer: Neon CI <neon@kde.org>

Package: kiss
Architecture: any
Depends: plasma-nm, ${misc:Depends}, ${shlibs:Depends}
Description: KDE Initial System Setup (KISS)
 The Out-of-the-box (OOTB) experience that greets a user after system
 installation or when starting up a new computer. Guides the user in creating
 the system's first user account and configuring initial settings.
 .
 Features include:
  * User account creation
  * Language selection
  * Keyboard layout selection
  * Time zone selection
  * Network configuration

## kiss 0.0.0+p24.04+vunstable+git20250901.0938

=== debian/changelog ===
kiss (0.0.0+p24.04+vunstable+git20250901.0938-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 01 Sep 2025 09:38:30 +0000

## kiss 0.13

=== src/Makefile ===
# Makefile for KISS

# The destination directory for a "make [rbg]install"
BINDIR=/usr/local/bin

# Your favorite C compiler:
CC = gcc

# Your installer, for "make (s)install": install or cp
INSTALL = install

# Default compile flags:
STDCFLAGS = -c -O2

# Warning level of compilation: I suggest -Wall
WARNFLAG = -Wall

# Additional compile flags for readline usage:
# You need to define USE_READLINE and to specifify the include dir,
# if you don't have readline under /usr/include. I have readline under
# /usr/local/include/readline.. If you don't want to compile with readline
# at all, just leave this out.
READLINECFLAGS =  -DUSE_READLINE -I/usr/local/include

# Additional compile flags for getline usage: Even if you don't have the
# readline libs (see above) and/or headers, I suggest you try out getline -
# it's a small readline-look-alike as far as command line editing goes.
# It doesn't support file completion though (it has hooks for it.. any
# potential heros out there?). The full sources for getline are under
# the getline/ subdir under this directory.
GETLINECFLAGS =  -DUSE_GETLINE -Igetline

# Additional compile flag for the bare version:
BARECFLAGS = -DUSE_BARE

# Default linkage flags: -s gives stripping. Always included, in all versions.
STDLFLAGS = -s

# Additional flags for readline: I have libreadline.a in /usr/local/lib,
# and readline requires libtermcap.a. If you don't want to compile with
# readline at all, just leave this out. Only included in "make rkiss".
READLINELFLAGS = -L/usr/local/lib -lreadline -ltermcap

# Additional linkage flags for getline: libgetline.a gets built under
# the subdir getline. Only included in "make gkiss".
GETLINELFLAGS = -Lgetline -lgetline

# Thazzal! The rest should be ok.
#-------------------------------

# objects that we're using
OBJ = kiss.o parser.tab.o lex.yy.o yyerror.o setstring.o setquotedstring.o \
      addstring.o clearstack.o setvariable.o warning.o getprogname.o \
      dumpstack.o error.o runcmd.o runchild.o setexpandedstring.o \
      sighandler.o getprompt.o banner.o redirected.o dokiss.o onechild.o \
      launch.o docat.o catfile.o domore.o morefile.o dohelp.o docp.o \
      copyfiletodir.o copyfiletofile.o copydirtodir.o runinternal.o docd.o \
      doquit.o getinput.o doexec.o dohistory.o addtohistory.o dorecall.o \
      islink.o getbasename.o setshlvl.o doprintenv.o dosetenv.o doecho.o \
      dounsetenv.o addtoenv.o dover.o domv.o movefiletodir.o \
      movefiletofile.o dowhere.o dorm.o dormdir.o removefile.o \
      recursiveremove.o domkdir.o dopwd.o dochgrp.o dochmod.o doln.o \
      doalias.o expandalias.o reexpand.o expandvars.o xmalloc.o xrealloc.o \
      xstrdup.o command.o waitforchild.o file2file.o doread.o dosource.o \
      sourcefile.o startupfiles.o isinternal.o isalias.o copystringstack.o \
      addstringstack.o expandtilde.o splitcmd.o addstringtostack.o \
      dokill.o dogrep.o dochown.o dosleep.o expandbackquotes.o dols.o \
      listdir.o listfile.o listoutput.o domknod.o dowc.o domount.o \
      doumount.o dotouch.o

# entry point for making
foo:
	@echo "Make what? Choose:"
	@echo "    make rkiss - make program in this dir, with readline"
	@echo "    make gkiss - make program in this dir, with getline"
	@echo "    make bkiss - make program in this dir, without editing"
	@echo "    make all - make readline, getline and bare versions"
	@echo "    make rinstall - \"make rkiss\" and install to" $(BINDIR)
	@echo "    make ginstall - \"make gkiss\" and install to" $(BINDIR)
	@echo "    make binstall - \"make bkiss\" and install to" $(BINDIR)
	@echo "    make clean - clean up stale files"
	exit 1

# how to make readline version
rkiss: always
	touch lexer
	make "CFLAGS=$(STDCFLAGS) $(READLINECFLAGS)" $(OBJ)
	$(CC) -o rkiss.new $(OBJ) $(READLINELFLAGS) $(STDLFLAGS)
	mv rkiss.new rkiss

# and install it
rinstall: rkiss
	$(INSTALL) rkiss $(BINDIR)

# how to make getline version
gkiss: always
	make -C getline libgetline.a
	touch lexer
	make "CFLAGS=$(STDCFLAGS) $(GETLINECFLAGS)" $(OBJ)
	$(CC) -o gkiss.new $(OBJ) $(GETLINELFLAGS) $(STDLFLAGS)
	mv gkiss.new gkiss

# and install it
ginstall: gkiss
	$(INSTALL) gkiss $(BINDIR)

# how to make bare version
bkiss: always
	touch lexer
	make "CFLAGS=$(STDCFLAGS) $(BARECFLAGS)" $(OBJ)
	$(CC) -o bkiss.new $(OBJ) $(STDLFLAGS)
	mv bkiss.new bkiss

# and install it
binstall: bkiss
	$(INSTALL) bkiss $(BINDIR)

# how to make both versions:
all:
	make rkiss
	make gkiss
	make bkiss

always:
	touch TimeStampOfCompilation

# extra: banner display needs version.h and subversion.h
banner.o: banner.c version.h subversion.h

# extra: "ver" command needs version.h and subversion.h
dover.o: dover.c version.h subversion.h

# how to make a new parser
parser.tab.c: parser
	bison -d parser

# how to make a new lexer
lex.yy.c: lexer parser.tab.h
	flex -I lexer

# suppress warnings on lexer
lex.yy.o: lex.yy.c
	@echo "Ignore any warnings in the lexer compilation"
	$(CC) $(CFLAGS) lex.yy.c

# suppress warnings on parser
parser.tab.o: parser.tab.c
	@echo "Ignore any warnings in the parser compilation"
	$(CC) $(CFLAGS) parser.tab.c

# cleanup: remove objects and intermediate files, but leave program
clean:
	rm -f $(OBJ) lex.yy.c parser.tab.c parser.tab.h a.out core \
	    TimeStampOfCompilation
	make -C getline clean

# how to get from *.c to *.o
.c.o:
	$(CC) $(CFLAGS) $(WARNFLAG) $<

=== src/getline/Makefile ===
CC     = gcc
CFLAGS = -Wall -DPOSIX
LDFLAGS= 

testgl: libgetline.a testgl.o
	$(CC) $(LDFLAGS) $(CFLAGS) -o testgl testgl.o -L. -lgetline

libgetline.a: getline.o
	ar cr libgetline.a getline.o
	-ranlib libgetline.a

clean:
	rm -f *.o *.a testgl

## kiss icp-0.2.3

=== CMakeLists.txt ===
# MIT License
#
# Copyright (c) 2022 Ignacio Vizzo, Tiziano Guadagnino, Benedikt Mersch, Cyrill
# Stachniss.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
cmake_minimum_required(VERSION 3.16...3.24)
project(kiss_icp_pybind VERSION 0.2.3 LANGUAGES CXX)

# Set build type
set(CMAKE_BUILD_TYPE Release)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../cpp/kiss_icp/)
  add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../cpp/kiss_icp ${CMAKE_CURRENT_BINARY_DIR}/kiss_icp)
else()
  cmake_minimum_required(VERSION 3.18)
  message(STATUS "Performing out-of-tree build, fetching KISS-ICP v${CMAKE_PROJECT_VERSION} Release from Github")
  include(FetchContent)
  FetchContent_Declare(
    ext_kiss_icp_core PREFIX kiss_icp_core
    URL https://github.com/PRBonn/kiss-icp/archive/refs/tags/v${CMAKE_PROJECT_VERSION}.tar.gz SOURCE_SUBDIR
        cpp/kiss_icp)
  FetchContent_MakeAvailable(ext_kiss_icp_core)
endif()

add_subdirectory(kiss_icp/pybind)

## kiss icp-0.2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,8 +20,8 @@
 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 # SOFTWARE.
-cmake_minimum_required(VERSION 3.16...3.24)
-project(kiss_icp_pybind VERSION 0.2.3 LANGUAGES CXX)
+cmake_minimum_required(VERSION 3.16...3.26)
+project(kiss_icp_pybind VERSION 0.2.5 LANGUAGES CXX)
 
 # Set build type
 set(CMAKE_BUILD_TYPE Release)

## kiss icp-0.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 # SOFTWARE.
 cmake_minimum_required(VERSION 3.16...3.26)
-project(kiss_icp_pybind VERSION 0.2.5 LANGUAGES CXX)
+project(kiss_icp_pybind VERSION 0.2.6 LANGUAGES CXX)
 
 # Set build type
 set(CMAKE_BUILD_TYPE Release)

## kiss icp-0.2.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 # SOFTWARE.
 cmake_minimum_required(VERSION 3.16...3.26)
-project(kiss_icp_pybind VERSION 0.2.6 LANGUAGES CXX)
+project(kiss_icp_pybind VERSION 0.2.7 LANGUAGES CXX)
 
 # Set build type
 set(CMAKE_BUILD_TYPE Release)

=== kiss_icp/pybind/CMakeLists.txt ===
# MIT License
#
# Copyright (c) 2022 Ignacio Vizzo, Tiziano Guadagnino, Benedikt Mersch, Cyrill
# Stachniss.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# Simply ignore the warnings when using scikit-build as the build system
if(${SKBUILD})
  set(ignore ${PYTHON_NumPy_INCLUDE_DIRS})
  set(ignore ${Python3_EXECUTABLE})
  set(ignore ${Python3_INCLUDE_DIR})
  set(ignore ${Python3_LIBRARY})
  set(ignore ${Python3_NumPy_INCLUDE_DIRS})
  set(ignore ${Python_EXECUTABLE})
  set(ignore ${Python_INCLUDE_DIR})
  set(ignore ${Python_LIBRARY})
  set(ignore ${Python_NumPy_INCLUDE_DIRS})
  set(ignore ${Python3_FIND_REGISTRY})
  set(ignore ${Python3_ROOT_DIR})
  set(ignore ${Python_FIND_REGISTRY})
  set(ignore ${Python_ROOT_DIR})
endif()

option(USE_SYSTEM_PYBIND11 "Use system pre-installed pybind11" ON)
if(USE_SYSTEM_PYBIND11)
  find_package(pybind11 QUIET)
endif()
if(NOT USE_SYSTEM_PYBIND11 OR NOT pybind11_FOUND)
  set(USE_SYSTEM_PYBIND11 OFF)
  include(${CMAKE_CURRENT_LIST_DIR}/pybind11/pybind11.cmake)
endif()

pybind11_add_module(kiss_icp_pybind MODULE kiss_icp_pybind.cpp)
target_link_libraries(kiss_icp_pybind PRIVATE kiss_icp::core kiss_icp::metrics)
install(TARGETS kiss_icp_pybind DESTINATION .)
